# CfnFlowOutput

The `AWS::MediaConnect::FlowOutput` resource defines the destination address, protocol, and port that AWS Elemental MediaConnect sends the ingested video to.

Each flow can have up to 50 outputs. An output can have the same protocol or a different protocol from the source. The following protocols are supported: RIST, RTP, RTP-FEC, SRT-listener, SRT-caller, Zixi pull, and Zixi push. CDI and ST 2110 JPEG XS protocols are not currently supported by AWS CloudFormation.

Extends: Construct › CfnElement › CfnRefElement › CfnResource › CfnFlowOutput
Implements: IInspectable, ITaggableV2, IEnvironmentAware, IFlowOutputRef, IConstruct, IDependable

- CloudFormation: [`AWS::MediaConnect::FlowOutput`](https://docs.aws.amazon.com/AWSCloudFormation/latest/TemplateReference/aws-resource-mediaconnect-flowoutput.html)
- Source: Generated code
- Type last changed: v2.260.0 · 16 Jun 2026

## Example

```ts
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import { aws_mediaconnect as mediaconnect } from 'aws-cdk-lib';

declare const automatic: any;
const cfnFlowOutput = new mediaconnect.CfnFlowOutput(this, 'MyCfnFlowOutput', {
  flowArn: 'flowArn',

  // the properties below are optional
  cidrAllowList: ['cidrAllowList'],
  description: 'description',
  destination: 'destination',
  encryption: {
    roleArn: 'roleArn',
    secretArn: 'secretArn',

    // the properties below are optional
    algorithm: 'algorithm',
    keyType: 'keyType',
  },
  maxLatency: 123,
  mediaStreamOutputConfigurations: [{
    encodingName: 'encodingName',
    mediaStreamName: 'mediaStreamName',

    // the properties below are optional
    destinationConfigurations: [{
      destinationIp: 'destinationIp',
      destinationPort: 123,
      interface: {
        name: 'name',
      },
    }],
    encodingParameters: {
      compressionFactor: 123,

      // the properties below are optional
      encoderProfile: 'encoderProfile',
    },
  }],
  minLatency: 123,
  name: 'name',
  ndiOutputTimecodeSource: 'ndiOutputTimecodeSource',
  ndiProgramName: 'ndiProgramName',
  ndiSpeedHqQuality: 123,
  outputStatus: 'outputStatus',
  port: 123,
  protocol: 'protocol',
  remoteId: 'remoteId',
  routerIntegrationState: 'routerIntegrationState',
  routerIntegrationTransitEncryption: {
    encryptionKeyConfiguration: {
      automatic: automatic,
      secretsManager: {
        roleArn: 'roleArn',
        secretArn: 'secretArn',
      },
    },

    // the properties below are optional
    encryptionKeyType: 'encryptionKeyType',
  },
  smoothingLatency: 123,
  streamId: 'streamId',
  tags: [{
    key: 'key',
    value: 'value',
  }],
  vpcInterfaceAttachment: {
    vpcInterfaceName: 'vpcInterfaceName',
  },
});
```

## Initializer

```ts
new CfnFlowOutput(scope: Construct, id: string, props: CfnFlowOutputProps)
```

## Construct Props

- `cidrAllowList`: string[] — The range of IP addresses that should be allowed to initiate output requests to this flow.

  These IP addresses should be in the form of a Classless Inter-Domain Routing (CIDR) block; for example, 10.0.0.0/16.

- `description`: string — A description of the output.

  This description appears only on the MediaConnect console and will not be seen by the end user.

- `destination`: string — The IP address where you want to send the output.

- `encryption`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnFlowOutput.EncryptionProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_mediaconnect.CfnFlowOutput.EncryptionProperty.html) — The type of key used for the encryption.

  If no `keyType` is provided, the service will use the default setting (static-key). Allowable encryption types: static-key.

- `flowArn`: string (required) — The Amazon Resource Name (ARN) of the flow this output is attached to.

- `maxLatency`: number — The maximum latency in milliseconds.

  This parameter applies only to RIST-based and Zixi-based streams.

- `mediaStreamOutputConfigurations`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnFlowOutput.MediaStreamOutputConfigurationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_mediaconnect.CfnFlowOutput.MediaStreamOutputConfigurationProperty.html)[] — The media streams that are associated with the output, and the parameters for those associations.

- `minLatency`: number — The minimum latency in milliseconds for SRT-based streams.

  In streams that use the SRT protocol, this value that you set on your MediaConnect source or output represents the minimal potential latency of that connection. The latency of the stream is set to the highest number between the sender’s minimum latency and the receiver’s minimum latency.

- `name`: string — The name of the bridge's output.

- `ndiOutputTimecodeSource`: string — The timecode source for the NDI output.

- `ndiProgramName`: string — A suffix for the names of the NDI sources that the flow creates.

  If a custom name isn't specified, MediaConnect uses the output name.

- `ndiSpeedHqQuality`: number — A quality setting for the NDI Speed HQ encoder.

- `outputStatus`: string — An indication of whether the output should transmit data or not.

- `port`: number — The port to use when content is distributed to this output.

- `protocol`: string — The protocol to use for the output.

  > AWS Elemental MediaConnect no longer supports the Fujitsu QoS protocol. This reference is maintained for legacy purposes only.

- `remoteId`: string — The remote ID for the Zixi-pull stream.

- `routerIntegrationState`: string

- `routerIntegrationTransitEncryption`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnFlowOutput.FlowTransitEncryptionProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_mediaconnect.CfnFlowOutput.FlowTransitEncryptionProperty.html) — Encryption information.

- `smoothingLatency`: number — The smoothing latency in milliseconds for RIST, RTP, and RTP-FEC streams.

- `streamId`: string — The stream ID that you want to use for this transport.

  This parameter applies only to Zixi and SRT caller-based streams.

- `tags`: [CfnTag](/cdk/api/v2/docs/aws-cdk-lib.CfnTag.html)[] — Key-value pairs that can be used to tag and organize this flow output.

- `vpcInterfaceAttachment`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnFlowOutput.VpcInterfaceAttachmentProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_mediaconnect.CfnFlowOutput.VpcInterfaceAttachmentProperty.html) — The name of the VPC interface attachment to use for this output.

## Properties

- `attrOutputArn`: string (required) — The ARN of the output.

- `cdkTagManager`: [TagManager](/cdk/api/v2/docs/aws-cdk-lib.TagManager.html) (required) — Tag Manager which manages the tags for this resource.

- `CFN_RESOURCE_TYPE_NAME`: string (required) (static) — The CloudFormation resource type name for this resource class.

- `cfnOptions`: [ICfnResourceOptions](/cdk/api/v2/docs/aws-cdk-lib.ICfnResourceOptions.html) (required) — Options for this resource, such as condition, update policy etc.

- `cfnResourceType`: string (required) — AWS resource type.

- `cidrAllowList`: string[] — The range of IP addresses that should be allowed to initiate output requests to this flow.

- `creationStack`: string[] (required)

- `description`: string — A description of the output.

- `destination`: string — The IP address where you want to send the output.

- `encryption`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnFlowOutput.EncryptionProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_mediaconnect.CfnFlowOutput.EncryptionProperty.html) — The type of key used for the encryption.

- `env`: [ResourceEnvironment](/cdk/api/v2/docs/aws-cdk-lib.interfaces.ResourceEnvironment.html) (required)

- `flowArn`: string (required) — The Amazon Resource Name (ARN) of the flow this output is attached to.

- `flowOutputRef`: [FlowOutputReference](/cdk/api/v2/docs/aws-cdk-lib.interfaces.aws_mediaconnect.FlowOutputReference.html) (required) — A reference to a FlowOutput resource.

- `logicalId`: string (required) — The logical ID for this CloudFormation stack element.

  The logical ID of the element
  is calculated from the path of the resource node in the construct tree.

  To override this value, use `overrideLogicalId(newLogicalId)`.

- `maxLatency`: number — The maximum latency in milliseconds.

- `mediaStreamOutputConfigurations`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnFlowOutput.MediaStreamOutputConfigurationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_mediaconnect.CfnFlowOutput.MediaStreamOutputConfigurationProperty.html)[] — The media streams that are associated with the output, and the parameters for those associations.

- `minLatency`: number — The minimum latency in milliseconds for SRT-based streams.

- `name`: string — The name of the bridge's output.

- `ndiOutputTimecodeSource`: string — The timecode source for the NDI output.

- `ndiProgramName`: string — A suffix for the names of the NDI sources that the flow creates.

- `ndiSpeedHqQuality`: number — A quality setting for the NDI Speed HQ encoder.

- `node`: [Node](/cdk/api/v2/docs/constructs.Node.html) (required) — The tree node.

- `outputStatus`: string — An indication of whether the output should transmit data or not.

- `port`: number — The port to use when content is distributed to this output.

- `protocol`: string — The protocol to use for the output.

- `ref`: string (required) — Return a string that will be resolved to a CloudFormation `{ Ref }` for this element.

  If, by any chance, the intrinsic reference of a resource is not a string, you could
  coerce it to an IResolvable through `Lazy.any({ produce: resource.ref })`.

- `remoteId`: string — The remote ID for the Zixi-pull stream.

- `routerIntegrationState`: string

- `routerIntegrationTransitEncryption`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnFlowOutput.FlowTransitEncryptionProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_mediaconnect.CfnFlowOutput.FlowTransitEncryptionProperty.html) — Encryption information.

- `smoothingLatency`: number — The smoothing latency in milliseconds for RIST, RTP, and RTP-FEC streams.

- `stack`: [Stack](/cdk/api/v2/docs/aws-cdk-lib.Stack.html) (required) — The stack in which this element is defined.

  CfnElements must be defined within a stack scope (directly or indirectly).

- `streamId`: string — The stream ID that you want to use for this transport.

- `tags`: [CfnTag](/cdk/api/v2/docs/aws-cdk-lib.CfnTag.html)[] — Key-value pairs that can be used to tag and organize this flow output.

- `vpcInterfaceAttachment`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnFlowOutput.VpcInterfaceAttachmentProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_mediaconnect.CfnFlowOutput.VpcInterfaceAttachmentProperty.html) — The name of the VPC interface attachment to use for this output.

## Methods

- `addDeletionOverride(path: string): void` — Syntactic sugar for `addOverride(path, undefined)`.

  **Parameters**

  - `path` — The path of the value to delete.

- `addDependency(target: CfnResource): void` — Use `addResourceDependency` instead.

  This method has been renamed to `addResourceDependency` to more clearly
  set it apart from `construct.node.addDependency`. See the documentation
  of that function for more details.

- `addDependsOn(target: CfnResource): void` — Use `addResourceDependency` instead.

  This can be used for resources across stacks (or nested stack) boundaries
  and the dependency will automatically be transferred to the relevant scope.

  This method has been renamed to `addResourceDependency`, which makes it
  more clear that this method operates at a different level from the
  construct-level `construct.node.addDependency()` mechanism.

- `addMetadata(key: string, value: any): void` — Add a value to the CloudFormation Resource Metadata.

- `addOverride(path: string, value: any): void` — Adds an override to the synthesized CloudFormation resource.

  To add a
  property override, either use `addPropertyOverride` or prefix `path` with
  "Properties." (i.e. `Properties.TopicName`).

  If the override is nested, separate each nested level using a dot (.) in the path parameter.
  If there is an array as part of the nesting, specify the index in the path.

  To include a literal `.` in the property name, prefix with a `\`. In most
  programming languages you will need to write this as `"\\."` because the
  `\` itself will need to be escaped.

  For example,
  ```typescript
  cfnResource.addOverride('Properties.GlobalSecondaryIndexes.0.Projection.NonKeyAttributes', ['myattribute']);
  cfnResource.addOverride('Properties.GlobalSecondaryIndexes.1.ProjectionType', 'INCLUDE');
  ```
  would add the overrides
  ```json
  "Properties": {
    "GlobalSecondaryIndexes": [
      {
        "Projection": {
          "NonKeyAttributes": [ "myattribute" ]
          ...
        }
        ...
      },
      {
        "ProjectionType": "INCLUDE"
        ...
      },
    ]
    ...
  }
  ```

  The `value` argument to `addOverride` will not be processed or translated
  in any way. Pass raw JSON values in here with the correct capitalization
  for CloudFormation. If you pass CDK classes or structs, they will be
  rendered with lowercased key names, and CloudFormation will reject the
  template.

  **Parameters**

  - `path` — - The path of the property, you can use dot notation to override values in complex types.
  - `value` — - The value.

- `addPropertyDeletionOverride(propertyPath: string): void` — Adds an override that deletes the value of a property from the resource definition.

  **Parameters**

  - `propertyPath` — The path to the property.

- `addPropertyOverride(propertyPath: string, value: any): void` — Adds an override to a resource property.

  Syntactic sugar for `addOverride("Properties.<...>", value)`.

  **Parameters**

  - `propertyPath` — The path of the property.
  - `value` — The value.

- `addResourceDependency(target: CfnResource, reason?: string): void` — Indicates that this resource depends on another resource and cannot be provisioned unless the other resource has been successfully provisioned.

  This can be used for resources across stacks (or nested stack) boundaries
  and the dependency will automatically be transferred to the relevant scope.

  This method only adds dependencies between L1 resources. If you are
  looking for a generic construct-to-construct dependency mechanism that works
  for all constructs including L2s, use `construct.node.addDependency` instead.

- `applyCrossStackReferenceStrength(strength: ReferenceStrength): void` — Sets the cross-stack reference strength for this resource.

  When set, any cross-stack reference to this resource will use the specified
  strength instead of the global default from the consuming stack's context.

  **Parameters**

  - `strength` — - The reference strength to use for this resource.

- `applyRemovalPolicy(policy?: RemovalPolicy, options?: RemovalPolicyOptions): void` — Sets the deletion policy of the resource based on the removal policy specified.

  The Removal Policy controls what happens to this resource when it stops
  being managed by CloudFormation, either because you've removed it from the
  CDK application or because you've made a change that requires the resource
  to be replaced.

  The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
  account for data recovery and cleanup later (`RemovalPolicy.RETAIN`). In some
  cases, a snapshot can be taken of the resource prior to deletion
  (`RemovalPolicy.SNAPSHOT`). A list of resources that support this policy
  can be found in the following link:

- `cfnPropertyName(cdkPropertyName: string): string`

- `getAtt(attributeName: string, typeHint?: ResolutionTypeHint): Reference` — Returns a token for an runtime attribute of this resource.

  Ideally, use generated attribute accessors (e.g. `resource.arn`), but this can be used for future compatibility
  in case there is no generated attribute.

  **Parameters**

  - `attributeName` — The name of the attribute.

- `getMetadata(key: string): any` — Retrieve a value value from the CloudFormation Resource Metadata.

- `inspect(inspector: TreeInspector): void` — Examines the CloudFormation resource and discloses attributes.

  **Parameters**

  - `inspector` — tree inspector to collect and process attributes.

- `isCfnElement(x: any): boolean` (static) — Returns `true` if a construct is a stack element (i.e. part of the synthesized cloudformation template).

  Uses duck-typing instead of `instanceof` to allow stack elements from different
  versions of this library to be included in the same stack.

  **Returns:** The construct as a stack element or undefined if it is not a stack element.

- `isCfnFlowOutput(x: any): boolean` (static) — Checks whether the given object is a CfnFlowOutput.

- `isCfnResource(x: any): boolean` (static) — Check whether the given object is a CfnResource.

- `isConstruct(x: any): boolean` (static) — Checks if `x` is a construct.

  Use this method instead of `instanceof` to properly detect `Construct`
  instances, even when the construct library is symlinked.

  Explanation: in JavaScript, multiple copies of the `constructs` library on
  disk are seen as independent, completely different libraries. As a
  consequence, the class `Construct` in each copy of the `constructs` library
  is seen as a different class, and an instance of one class will not test as
  `instanceof` the other class. `npm install` will not create installations
  like this, but users may manually symlink construct libraries together or
  use a monorepo tool: in those cases, multiple copies of the `constructs`
  library can be accidentally installed, and `instanceof` will behave
  unpredictably. It is safest to avoid using `instanceof`, and using
  this type-testing method instead.

  **Parameters**

  - `x` — Any object.

  **Returns:** true if `x` is an object created from a class which extends `Construct`.

- `obtainDependencies(): Stack | CfnResource[]` — Retrieves an array of resources and stacks this resource depends on.

  For resources depended on directly, returns the `CfnResource` object. For
  dependencies on other stacks, returns the `Stack` object. The order of the
  array is not guaranteed.

- `overrideLogicalId(newLogicalId: string): void` — Overrides the auto-generated logical ID with a specific ID.

  **Parameters**

  - `newLogicalId` — The new logical ID to use for this stack element.

- `removeDependency(target: CfnResource): void` — Use `removeResourceDependency` instead

  This can be used for resources across stacks (including nested stacks)
  and the dependency will automatically be removed from the relevant scope.

- `removeResourceDependency(target: CfnResource): void` — Indicates that this resource no longer depends on another resource.

  This can be used for resources across stacks (including nested stacks)
  and the dependency will automatically be removed from the relevant scope.

- `replaceDependency(target: CfnResource, newTarget: CfnResource): void` — Replaces one dependency with another.

  **Parameters**

  - `target` — The dependency to replace.
  - `newTarget` — The new dependency to add.

- `toString(): string` — Returns a string representation of this construct.

  **Returns:** a string representation of this resource

- `with(...mixins: IMixin[]): IConstruct` — Applies one or more mixins to this construct.

  Mixins are applied in order. The list of constructs is captured at the
  start of the call, so constructs added by a mixin will not be visited.
  Use multiple `with()` calls if subsequent mixins should apply to added
  constructs.
